include \masm32\include\masm32rt.inc

; optional:  1 (or nothing) for jj2007's strlen32s (includes a check for SSE2 capability), 
; SlenUseAlgos=1		;  2 for Lingo's strlen64B, 4 fot NightWare's NWStrLen

include \masm32\include\slenSSE2.inc
include \masm32\macros\timers.asm

txt50	equ <"Just some stpid text containing exctly 50 bytes ">
.data
szTest_1	db "My short string", 0

	align 16
	db 0, 0, 0		; misaligned 16+3
szTest_16k	db txt50
	REPEAT 320-1+6
		db txt50
	ENDM
	db txt50, "16384 bytes***********************", 0

.code
start:
	tmp$ CATSTR <chr$("Timings for >, StrLenAlgo$, <:")>
	print tmp$, 13, 10, 10

	counter_begin 500000, HIGH_PRIORITY_CLASS
		  mov esi, len(offset szTest_1)
	counter_end
	print str$(eax), 9, "cycles for len="
	print str$(esi), 13, 10

	counter_begin 500000, HIGH_PRIORITY_CLASS
		  mov esi, len(offset szTest_16k)
	counter_end
	print str$(eax), 9, "cycles for len="
	print str$(esi), 13, 10, 10, 10

	print chr$("Timings for Masm32lib szLen:"), 13, 10, 10

	counter_begin 500000, HIGH_PRIORITY_CLASS
		invoke szLen, offset szTest_1
		mov esi, eax
	counter_end
	print str$(eax), 9, "cycles for len="
	print str$(esi), 13, 10

	counter_begin 500000, HIGH_PRIORITY_CLASS
		invoke szLen, offset szTest_16k
		mov esi, eax
	counter_end
	print str$(eax), 9, "cycles for len="
	print str$(esi), 13, 10, 10, 9, 9, 9, 9, "-- hit any key --"
	getkey
	exit
end start
OPT_WAIT	0
OPT_Tmp2Asm	1

